package test
{
	import it.sephiroth.scripting.utils.RegexLexer;
	import it.sephiroth.scripting.utils.RegexLexerContext;
	import it.sephiroth.scripting.utils.Token;
	
	public class ExprLexer extends RegexLexer
	{
		public function ExprLexer( source_name: String, input: String )
		{
			super( source_name, input );
			
			addRule( "nl",			"\n",							-1,			onNL );
			addRule( "space",		"[ \t]+", 						-1,			RegexLexer.SKIP );
			addRule( "number",		"[1-9][0-9]*",					Tokens.NUM, onNumber );
			addRule( "symbol",		"\\+|\\-|\\*|/|\\^|\\(|\\)",	-1,			onSymbol );
		}
		
		private function onSymbol( context: RegexLexerContext ): void
		{
			var token: Token;
			
			token = new Token(
				context.token.value.charCodeAt( 0 ),
				context.token.value,
				context.token.sourceName,
				context.token.charno,
				context.token.lineno,
				context.token.columnno );
			
			context.token = token;
		}
		
		private function onNL( context: RegexLexerContext ): void
		{
			var token: Token;
			
			token = new Token(
				context.token.value.charCodeAt( 0 ),
				context.token.value,
				context.token.sourceName,
				context.token.charno,
				context.token.lineno + 1,
				context.token.columnno );
			
			context.token = token;
		}
		
		private function onNumber( context: RegexLexerContext ): void
		{
			var token: Token;
			var value: Number;
			
			value = parseInt( context.token.value );
			token = new Token(
				context.token.type,
				value,
				context.token.sourceName,
				context.token.charno,
				context.token.lineno,
				context.token.columnno );
			
			context.token = token;
		}
	}
}