package test
{
	import it.sephiroth.scripting.utils.Token;
	
	public class ExprParser extends Parser
	{
		private var _token: Token;
		private var _lexer: ExprLexer;
		
		public function ExprParser()
		{
			super();
		}
		
		public function evaluate( input: String ): void
		{
			_lexer = new ExprLexer( "<input>", input );
			yyparse();
		}
		
		override public function yylex(): int
		{
			var value: Token = _lexer.next()
		
			if( value == null || value.type == Token.EOF )
			{
				return 0;
			}
			
			set_yylval( value.value );
			
			_token = value;
			
			return value.type;
		}
		
		override public function yyerror( msg: String ): void
		{
			trace( msg, "at", _token.lineno + ":" + _token.charno ); 
		}
		
	}
}